/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.JenisProdukDao;
import com.portofolio.dto.JenisProdukDto;
import com.portofolio.entity.JenisProduk;
import com.portofolio.entity.vo.JenisProdukId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class JenisProdukService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private JenisProdukDao jenisProdukDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(JenisProdukDto jenisProdukDto) {
		result.clear();
		JenisProdukId id = new JenisProdukId();
		Integer kdJenisProduk =getIdTerahir(JenisProduk.class.getSimpleName());
		id.setKdJenisProduk(kdJenisProduk);
		id.setKdProfile(getKdProfile());
		JenisProduk jenisProduk = CommonUtil.findOne(jenisProdukDao, id);
		if (CommonUtil.isNullOrEmpty(jenisProduk)) {
			jenisProduk = new JenisProduk();
			BeanUtils.copyProperties(jenisProdukDto, jenisProduk);
			jenisProduk.setNoRec(generateUuid32());
			jenisProduk.setVersion(1);
			jenisProduk.setId(id);
			jenisProduk = jenisProdukDao.save(jenisProduk);
			result.put("jenisProduk", jenisProduk);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("jenisProduk.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(JenisProdukDto jenisProdukDto, Integer kdJenisProduk, Integer version) {
		result.clear();
		JenisProdukId id = new JenisProdukId();
		id.setKdJenisProduk(kdJenisProduk);
		id.setKdProfile(getKdProfile());
		JenisProduk jenisProduk = CommonUtil.findOne(jenisProdukDao, id);
		if (CommonUtil.isNotNullOrEmpty(jenisProduk)) {
			if (version < jenisProduk.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(jenisProdukDto, jenisProduk);
			jenisProduk.setVersion(version);
			jenisProduk = jenisProdukDao.save(jenisProduk);
			result.put("jenisProduk", jenisProduk);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaJenisProduk,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaJenisProduk)) {
			pageRes = jenisProdukDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = jenisProdukDao.findAllList(getKdProfile(), namaJenisProduk, statusEnabled, pageReq);
		}
		result.put("jenisProduk", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdJenisProduk(Integer kdJenisProduk) {
		result.clear();
		result.put("jenisProduk", jenisProdukDao.findByKdJenisProduk(getKdProfile(), kdJenisProduk, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdJenisProduk, Integer version) {
		result.clear();
		JenisProdukId id = new JenisProdukId();
		id.setKdJenisProduk(kdJenisProduk);
		id.setKdProfile(getKdProfile());
		JenisProduk jenisProduk = CommonUtil.findOne(jenisProdukDao, id);
		if (CommonUtil.isNotNullOrEmpty(jenisProduk)) {
			if (version < jenisProduk.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			jenisProduk.setStatusEnabled(false);
			jenisProduk.setVersion(version);
			jenisProduk = jenisProdukDao.save(jenisProduk);
			result.put("jenisProduk", jenisProduk);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
